unit arena2_gfx;
interface

  type
    TRGB = packed record
      R: byte;
      G: byte;
      B: byte;
    end;
    TPAL = packed array[0..255] of TRGB;
    TCOL = packed record
      Size: longword; // always 776
      Magic: word; // always $B123
      Color: TPAL;
    end;

    TPaletteShiftLUTSet = packed array[0..63, 0..255] of byte; // HAZE and SHADE file struct

    TSKYImage = array[1..102400] of byte;
    TSKYData = packed record
      Palette: array[0..31] of TCOL;
      FadeInLUT: array[0..31] of TPaletteShiftLUTSet;
      Image: array[0..1, 0..31] of TSKYImage; // image[0, n] = no sun; image[1, n] = with sun
    end;

    TIMGHeader = packed record
      XOffset: word;
      YOffset: word;
      Width: word;
      Height: word;
      Unknown: word;
      ImageSize: word;
    end;

    TWeaponCIFHeader = packed record
      Width: word;
      Height: word;
      XOffset: word;
      YOffset: word;
      Unknown: word;
      ImageSize: word;
      ImageOffset: packed array[1..32] of word;
    end;

    TTextureHeader = packed record
      NumImages: word;
      TextureName: array[1..24] of char;
    end;

    TTextureInfo = packed record
      Type1: word;
      Offset: longword;
      Type2: word;
      Unknown1: longword;
      NullValue1: longword;
      NullValue2: longword;
    end;

    TTextureImageHeader = packed record
      XOffset: word;
      YOffset: word;
      Width: word;
      Height: word;
      Unknown1: word;
{	0x0108 = Image has subimages which are RLE compressed data.
	0x1108 = Image has RLE type compressed data with a row offset
		 section before the single image data.	}
      ImageSize: longword;
      ImageOffset: longword;
      Unknown2: word;
{	0x0000 = Image has subimages in special compressed format.
	0x00C0 = Usual value, regular single image.
	NonZero = Regular single image. Unknown what the differences
		  in the values indicate.	}
      NumSubImages: word;
      Unknown3: longword;
      Unknown4: word;
    end;

implementation
end.
